]> git.pld-linux.org Git - packages/percona-server.git/blame - mysql.init
- release 2
[packages/percona-server.git] / mysql.init
CommitLineData
53a28f77 1#!/bin/sh
2#
7429b124 3# mysql A very fast and reliable SQL database engine
53a28f77 4#
7429b124 5# chkconfig: 2345 84 25
53a28f77 6#
350d9d8c 7# description: A very fast and reliable SQL database engine.
53a28f77 8#
0b079830
ER
9# $Id$
10
53a28f77 11# Source function library
12. /etc/rc.d/init.d/functions
13
14# Get network config
15. /etc/sysconfig/network
16
aac2c31f
AM
17# Get service config
18if [ -f /etc/sysconfig/mysql ]; then
350d9d8c 19 . /etc/sysconfig/mysql
aac2c31f 20else
350d9d8c 21 nls "Error: %s not found" /etc/sysconfig/mysql
95b0575d 22 nls "%s can't be run." MySQL
350d9d8c
PG
23 exit 1
24fi
25
0146fae1 26if [ -n "$MYSQL_DB_CLUSTERS" ]; then
350d9d8c 27 nls "Warning: MYSQL_DB_CLUSTERS is set. It's obsolete. Use %s instead." /etc/mysql/clusters.conf
aac2c31f
AM
28fi
29
95b0575d 30if [ -f /etc/mysql/clusters.conf ]; then
0ca65658 31 MYSQL_DB_CLUSTERS=$(awk -F= '!/^#/{print $2}' /etc/mysql/clusters.conf)
95b0575d
ER
32 if [ -z "$MYSQL_DB_CLUSTERS" ]; then
33 nls "Warning: there are no configured clusters."
34 fi
0146fae1 35
95b0575d 36else
0146fae1 37 nls "Warning: Missing clusters config file %s" /etc/mysql/clusters.conf
95b0575d
ER
38 if [ -z "$MYSQL_DB_CLUSTERS" ]; then
39 nls "Warning: there are no configured clusters."
40 nls "Using default cluster /var/lib/mysql (compatibility mode)"
41 MYSQL_DB_CLUSTERS=/var/lib/mysql
42 fi
aac2c31f
AM
43fi
44
95b0575d 45
ac28c610 46# Check that networking is up
8eb71226 47if is_yes "${NETWORKING}"; then
213fc2f2 48 if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status -a "$1" != init ]; then
8eb71226 49 msg_network_down MySQL
50 exit 1
51 fi
52else
53 exit 0
e9ca44ab 54fi
55
aac2c31f
AM
56action="$1"
57
58# any db cluster as command line argument?
521444a9 59if [ $# -gt 1 ]; then
350d9d8c
PG
60 shift
61 # perform action for specified clusters only
30b2aa9a
ER
62 for a in "$@"; do
63 # try auto resolving from /etc/mysql/clusters.conf
64 if [[ "$a" != /* ]]; then
65 m=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $1}' /etc/mysql/clusters.conf)
66 if [ -z "$m" ]; then
67 echo >&2 "Cluster name '$a' did not match anything!"
68 exit 1
69 fi
70 if [ $(echo "$m" | wc -l) -gt 1 ]; then
71 echo >&2 "Cluster name '$a' ambiguous:" $m
72 exit 1
73 fi
74 a=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $2}' /etc/mysql/clusters.conf)
75 fi
76 DB_CLUSTERS="$DB_CLUSTERS $a"
77 done
aac2c31f 78else
350d9d8c 79 DB_CLUSTERS="$MYSQL_DB_CLUSTERS"
53a28f77 80fi
81
7c1478d5
ER
82# global error log, if mysqld.conf hasn't migrated to log-error style
83MYSQL_ERRLOG=/var/log/mysql/mysqld.log
c85758f0 84MYSQL_STOP_WAIT_TIME=${MYSQL_STOP_WAIT_TIME:-900}
aac2c31f
AM
85
86#
87# Useful functions.
88#
89
90#
91# check for mysql status
92#
93# arguments:
94# $1 - db cluster
c85758f0 95# $2 - start|stop
aac2c31f
AM
96#
97# sets variables:
c85758f0 98# MYSQL_STATUS = starting | running | not running | died
aac2c31f
AM
99# MYSQL_PID = pid of mysqld process
100#
101mysqlstatus() {
102 clusterdir="$1"
c85758f0
AM
103 mode="$2"
104
aac2c31f 105 mysqlgetconfig "$clusterdir"
d405c4eb 106
350d9d8c
PG
107 MYSQL_STATUS="not running"
108 MYSQL_PID="unknown"
c85758f0
AM
109 MYSQL_PIDFILE_PID=""
110 MYSQL_GREP_PID=""
aac2c31f 111
c85758f0
AM
112 if [ -f "$MYSQL_PIDFILE" ]; then
113 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
114 fi
115
116 if [ -n "$MYSQL_PIDFILE_PID" ]; then
117 MYSQL_PID=$MYSQL_PIDFILE_PID
118 if [ ! -d "/proc/$MYSQL_PID" ]; then
119 MYSQL_STATUS="died"
120 return
376ffa12 121 elif (grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null); then
c85758f0
AM
122 MYSQL_STATUS="running"
123 return
124 fi
125 fi
6d3c5db5 126
c85758f0 127 if [ "$mode" = "start" ]; then
376ffa12 128 MYSQL_GREP_PID=$(grep -lE "^/usr/sbin/mysqld.*${MYSQL_PIDFILE}" /proc/[0-9]*/cmdline 2> /dev/null | awk -F "/" '{ print $3; exit; }')
c85758f0
AM
129 if [ -n "$MYSQL_GREP_PID" ]; then
130 MYSQL_PID=$MYSQL_GREP_PID
0ca65658 131 if grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null; then
c85758f0
AM
132 if [ -f "$MYSQL_PIDFILE" ]; then
133 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
134 fi
135 if [ -n "$MYSQL_PIDFILE_PID" ]; then
136 MYSQL_PID=$MYSQL_PIDFILE_PID
137 MYSQL_STATUS="running"
138 return
139 else
140 MYSQL_STATUS="starting"
141 return
142 fi
143 fi
144 fi
6d3c5db5 145 fi
c85758f0
AM
146
147 # else default, "not running"
aac2c31f
AM
148}
149
150# get mysql configuration in variables
5e3157a9 151# MYSQL_CONFIG MYSQL_CLUSTER_DIR
e6d4b62c 152# MYSQL_DATA_DIR MYSQL_USER MYSQL_PIDFILE MYSQL_SOCKET MYSQL_PORT MYSQL_BIND_ADDRESS MYSQL_SKIP_NETWORKING MYSQL_LOG_ERROR
aac2c31f
AM
153#
154# arguments
155# $1 - db cluster
156
157mysqlgetconfig() {
5e3157a9 158 local clusterdir="$1" config_file
aac2c31f
AM
159
160 # emulate old behaviour if only one cluster specified
161 if [ "$clusterdir" = "$MYSQL_DB_CLUSTERS" -a "$clusterdir" = "/var/lib/mysql" -a -f /etc/mysqld.conf ]; then
0ca65658 162 MYSQL_RA_COMPAT=yes
aac2c31f 163 config_file=/etc/mysqld.conf
521444a9 164 else
5e3157a9 165 local config=$(awk -F= -vclusterdir="$clusterdir" '!/^#/{ if (clusterdir == $2) print $1}' /etc/mysql/clusters.conf)
0ca65658 166 if [[ $config = /* ]]; then
d54e166d 167 config_file="$config"
fe2f6e01 168 elif [ -f "/etc/mysql/$config" ]; then
0ca65658 169 config_file="/etc/mysql/$config"
d54e166d
AM
170 else
171 config_file="$clusterdir/mysqld.conf"
172 fi
350d9d8c 173 fi
aac2c31f 174
0ca65658 175 MYSQL_CLUSTER_DIR="$clusterdir"
d405c4eb 176
521444a9 177 if [ -z "$config_file" ]; then
f9ad67df
PG
178 nls "Error: Can't find config file for %s cluster" "$clusterdir"
179 exit 6
180 else
0ca65658 181 MYSQL_CONFIG="$config_file"
f9ad67df 182 fi
d405c4eb 183
aac2c31f
AM
184 if [ ! -f "$config_file" ]; then
185 nls "Error: config file %s not found" "$config_file"
350d9d8c
PG
186 nls "MySQL can't be run. Did you initialize DB by doing \`$0 init'?"
187 exit 6
aac2c31f
AM
188 fi
189
b3be1198 190 # reset to initial state
e6d4b62c 191 MYSQL_DATA_DIR= MYSQL_USER= MYSQL_PIDFILE= MYSQL_SOCKET= MYSQL_PORT= MYSQL_BIND_ADDRESS= MYSQL_SKIP_NETWORKING= MYSQL_LOG_ERROR=
b3be1198
ER
192
193 eval `awk -F= '
194 # skip comments and empty lines
195 /^[;#]|^ *$/ { next }
196
197 /^[ \t]*\[.*\][ \t]*$/ {
198 match($0, /\[.*\]/);
199 section = substr($0, RSTART + 1, RSTART + RLENGTH - 3);
200 next;
823c13f7 201 }
e9ca44ab 202
b3be1198
ER
203 # trim spaces
204 {
205 gsub(/^[\t ]*|[\t ]*$/, "", $1);
206 gsub(/^[\t ]*|[\t ]*$/, "", $2);
207 }
208
209 section == "mysqld" {
210 if ($1 == "datadir") {
211 printf("MYSQL_DATA_DIR=%s;", $2);
212 } else if ($1 == "user") {
213 printf("MYSQL_USER=%s;", $2);
214 } else if ($1 == "pid-file") {
215 printf("MYSQL_PIDFILE=%s;", $2);
216 } else if ($1 == "socket") {
217 printf("MYSQL_SOCKET=%s;", $2);
218 } else if ($1 == "port") {
219 printf("MYSQL_PORT=%s;", $2);
220 } else if ($1 == "bind-address") {
221 printf("MYSQL_BIND_ADDRESS=%s;", $2);
9e39a858
ER
222 } else if ($1 == "skip-networking") {
223 printf("MYSQL_SKIP_NETWORKING=1;");
e6d4b62c
ER
224 } else if ($1 == "log-error") {
225 printf("MYSQL_LOG_ERROR=%s;", $2);
b3be1198
ER
226 }
227 }
228 ' $config_file`
e9ca44ab 229
e6d4b62c
ER
230 # error log not defined in config file. add one
231 if [ -z "$MYSQL_LOG_ERROR" ]; then
232 MYSQL_LOG_ERROR=$MYSQL_ERRLOG
233 else
234 # unset, so mysqld would use value from config itself
235 unset MYSQL_LOG_ERROR
236 fi
237
d54e166d 238 if is_yes "$MYSQL_RA_COMPAT"; then
350d9d8c 239 MYSQL_DATA_DIR_SUB=""
8ee1d59c 240 else
350d9d8c 241 MYSQL_DATA_DIR_SUB="/mysqldb"
8ee1d59c 242 fi
d405c4eb 243
8ee1d59c 244 if [ -z "$MYSQL_DATA_DIR" -o "$MYSQL_DATA_DIR" != "${clusterdir}${MYSQL_DATA_DIR_SUB}/db" ]; then
350d9d8c
PG
245 nls "Error: datadir specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/db"
246 nls " MySQL can't be run."
247 exit 6
8ee1d59c 248 fi
d405c4eb 249
8ee1d59c
AM
250 if [ -z "$MYSQL_PIDFILE" -o "$MYSQL_PIDFILE" != "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid" ]; then
251 nls "Error: pid-file specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid"
252 nls " MySQL can't be run."
253 exit 6
254 fi
e9ca44ab 255
e6d4b62c 256 if [ -z "$MYSQL_USER" ]; then
350d9d8c
PG
257 echo "$(nls 'MySQL user not configured properly')"'!' >&2
258 nls "Edit %s and configure it." "$config_file" >&2
259 exit 6
860cd80c 260 fi
aac2c31f 261}
e9ca44ab 262
aac2c31f
AM
263# start mysql
264mysqlstart() {
5e3157a9 265 local clusterdir="$1"
aac2c31f
AM
266 mysqlgetconfig "$clusterdir"
267 if [ ! -d "$MYSQL_DATA_DIR/mysql" ]; then
268 nls "MySQL cluster %s not initialized." "$clusterdir"
269 nls "Try \`%s init %s' before start." "$0" "$clusterdir"
350d9d8c
PG
270 exit 6
271 fi
02e96f2e 272
5e3157a9 273 msg_starting "MySQL $clusterdir"; busy
aac2c31f 274 [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
c85758f0 275 rm -f "$MYSQL_PIDFILE"
c4fbabf1 276
7c1478d5 277
c4fbabf1 278 TMPDIR=/tmp nice -n ${SERVICE_RUN_NICE_LEVEL:-$DEFAULT_SERVICE_RUN_NICE_LEVEL} \
7429b124 279 /usr/bin/setsid /usr/sbin/mysqld \
c4fbabf1
ER
280 --defaults-file=$MYSQL_CONFIG \
281 --datadir=$MYSQL_DATA_DIR \
7c1478d5 282 --pid-file=$MYSQL_PIDFILE \
e6d4b62c 283 ${MYSQL_LOG_ERROR:+--log-error="$MYSQL_LOG_ERROR"} \
7c1478d5 284 $MYSQL_OPTIONS &
c4fbabf1
ER
285 pid=$!
286
287 sleep 0.1
c85758f0
AM
288 mysqlstatus "$clusterdir" start
289 # it takes longer for mysqld to start and create pidfile if it has to recover innodb transactions
290 if [ "$MYSQL_STATUS" = "starting" ]; then
c4fbabf1
ER
291 echo ""
292 show "Waiting for MySQL to start"
293 busy
294
295 # while the pid is running, mysql is starting up
296 # if the pidfile was created, it started up successfully
297 # if either case fails we break and report status
298 while true; do
299 [ -d /proc/$pid ] || break
c85758f0 300 [ -f "$MYSQL_PIDFILE" ] && break
c4fbabf1 301 sleep 0.2
c85758f0
AM
302 done
303 fi
304
305 mysqlstatus "$clusterdir" start
6d3c5db5 306 if [ "$MYSQL_STATUS" = "running" -a "$MYSQL_PID" != "unknown" ]; then
aac2c31f 307 ok
47fd5a6a 308 elif [ "$MYSQL_STATUS" = "died" ]; then
350d9d8c 309 RETVAL=1
47fd5a6a 310 died
aac2c31f
AM
311 else
312 RETVAL=1
313 fail
53a28f77 314 fi
aac2c31f
AM
315}
316
317# stop mysql
318mysqlstop() {
5e3157a9 319 local clusterdir="$1"
c85758f0 320 mysqlstatus "$clusterdir" stop
aac2c31f
AM
321 msg_stopping "MySQL $clusterdir"
322 busy
95b0575d 323
95b0575d 324 # try graceful shutdown -- send shutdown command
566e62bb 325 # requires mysql_sysadmin user proper privs
465c110e 326 /usr/bin/mysqladmin --defaults-file=$MYSQL_CONFIG ${MYSQL_SOCKET:+--socket=$MYSQL_SOCKET} shutdown >/dev/null 2>&1
c85758f0 327 mysqlstatus "$clusterdir" stop
95b0575d 328
c85758f0
AM
329 if [ "$MYSQL_PID" != "unknown" ]; then
330 kill -TERM "$MYSQL_PID" 2> /dev/null
331 for nr in $(seq 1 $(($MYSQL_STOP_WAIT_TIME*10))); do
332 [ -d "/proc/$MYSQL_PID" ] || break
333 sleep 0.1
334 done
335 fi
336
337 mysqlstatus "$clusterdir" stop
47fd5a6a 338 if [ "$MYSQL_STATUS" = "died" ]; then
350d9d8c 339 died
c85758f0 340 elif [ "$MYSQL_STATUS" = "running" -o "$MYSQL_STATUS" = "starting" ]; then
aac2c31f 341 fail
b92e5cd1 342 else
aac2c31f 343 ok
b92e5cd1 344 fi
aac2c31f
AM
345}
346
347#
348# check for running mysql instances; if any instance is running then
349# create subsys lock file
350#
351mysqlsubsys() {
350d9d8c
PG
352 # check for every defined db cluster in sysconfig file
353 for mysqldir in $DB_CLUSTERS; do
354 mysqlstatus "$mysqldir"
355 if [ "$MYSQL_STATUS" = "running" ]; then
356 touch /var/lock/subsys/mysql
357 return
358 fi
359 done
360 rm -f /var/lock/subsys/mysql
aac2c31f
AM
361}
362
363mysqlinit() {
5e3157a9 364 local clusterdir="$1"
8ee1d59c
AM
365
366 if [ -f /etc/mysqld.conf ]; then
350d9d8c
PG
367 nls "Running in \`no cluster compat' mode: can't initialize database."
368 nls "Move /etc/mysqld.conf away and rerun \`$0 init' (new config will be in $clusterdir)."
369 exit 1
8ee1d59c
AM
370 fi
371
521444a9
AM
372 if [ -f "$clusterdir/mysqld.conf" ]; then
373 mysqlgetconfig "$clusterdir"
374 else
375 MYSQL_USER="mysql"
376 MYSQL_CLUSTER_DIR="$clusterdir"
377 MYSQL_DATA_DIR="$clusterdir/mysqldb/db"
378 MYSQL_PIDFILE="$clusterdir/mysqldb/mysql.pid"
379 MYSQL_SOCKET="$clusterdir/mysqldb/mysql.sock"
fe98cc4a
ER
380
381 # this $MYSQL_CONFIG will be created later
382 MYSQL_CONFIG="$MYSQL_CLUSTER_DIR/mysqld.conf"
521444a9 383 fi
aac2c31f 384
d460d24d 385 show "Initializing cluster %s" "$clusterdir"; echo
aac2c31f 386
573e1dcc 387 # Check if not exist init database
e9ca44ab 388 if [ -d "$MYSQL_DATA_DIR/mysql" ]; then
c70c8930 389 nls "Seems that database is initialized now. Remove by hand %s" "$MYSQL_DATA_DIR/mysql"
b92e5cd1 390 nls "before initializing database."
aac2c31f
AM
391 nls "For now skipping cluster %s." "$clusterdir"
392 return
e9ca44ab 393 fi
394
5f961775 395 show "Installing MySQL system tables for $MYSQL_DATA_DIR"
e9ca44ab 396 busy
d405c4eb
JB
397 TMP=/tmp TMPDIR=/tmp
398
c4fbabf1 399 mkdir -p "$MYSQL_DATA_DIR" > /dev/null 2>&1
f5d63301
AM
400 # Using mysql:mysql for MYSQL_CLUSTER_DIR is creating SECURITY hole, root:root is proper
401 chown root:root "$MYSQL_CLUSTER_DIR"
5f961775 402 chown mysql:mysql "$MYSQL_CLUSTER_DIR/mysqldb" "$MYSQL_DATA_DIR" > /dev/null 2>&1
653cf157 403 chmod 751 "$MYSQL_CLUSTER_DIR" "$MYSQL_CLUSTER_DIR/mysqldb"
444f9f3c
AM
404
405 if [ -f /usr/share/mysql/mysqld.conf -a ! -f "$MYSQL_CLUSTER_DIR/mysqld.conf" ]; then
b6369c60
ER
406 sed -e "
407 s#\(datadir.*\)=.*#\1= $MYSQL_DATA_DIR#g;
408 s#\(pid-file.*\)=.*#\1= $MYSQL_PIDFILE#g;
409 s#\(socket.*\)=.*#\1= $MYSQL_SOCKET#g;
410 s#@clusterdir@#$MYSQL_CLUSTER_DIR#g;
411 " /usr/share/mysql/mysqld.conf > "$MYSQL_CLUSTER_DIR/mysqld.conf"
54a1f368 412 chown root:root "$MYSQL_CLUSTER_DIR/mysqld.conf"
444f9f3c
AM
413 chmod 640 "$MYSQL_CLUSTER_DIR/mysqld.conf"
414 fi
cc4d3f78 415
a08fc1eb 416 if [ ! -e /var/lib/mysql/mysql.sock ] || [ -L /var/lib/mysql/mysql.sock ] && [ -z "$(readlink /var/lib/mysql/mysql.sock)" ]; then
0ca65658 417 sock=${MYSQL_SOCKET#/var/lib/mysql/} # make it relative if possible
5fe13e55 418 ln -s "$sock" /var/lib/mysql/mysql.sock
cc4d3f78 419 fi
aac2c31f 420
b9c4f95d 421 cat > $MYSQL_DATA_DIR/mysql-init.sql <<-EOF
bb39d376 422 CREATE DATABASE mysql;
4444725f 423 use mysql;
ac02fcd5 424 $(cat /usr/share/mysql/mysql_system_tables.sql)
5f961775 425 $(sed -e "/@current_hostname/d" /usr/share/mysql/mysql_system_tables_data.sql)
b9c4f95d
ER
426EOF
427
428 ok=0
5ab9fb7b
JR
429 /usr/sbin/mysqld \
430 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
431 --bootstrap \
432 --skip-grant-tables \
9b5b7a74 433 --skip-innodb \
5ab9fb7b
JR
434 --datadir=$MYSQL_DATA_DIR \
435 --user=$MYSQL_USER \
436 --slave-load-tmpdir=$MYSQL_DATA_DIR \
437 --tmpdir=$MYSQL_DATA_DIR \
438 --log-error=$MYSQL_ERRLOG \
da87c30d 439 < $MYSQL_DATA_DIR/mysql-init.sql && ok=1
5062ac41 440 [ -f $MYSQL_DATA_DIR/mysql/host.frm ] || ok=0
c4fbabf1 441
b9c4f95d
ER
442 if [ "$ok" = 1 ]; then
443 rm -f $MYSQL_DATA_DIR/mysql-init.sql
5f961775
JR
444 ok
445 cat << END_OF_MSG
6a46c354 446
447PLEASE REMEMBER TO SET A PASSWORD FOR THE MySQL USERS!
5f961775
JR
448This is done, after starting database, in the order shown,
449with:
450
451For 'mysql_sysadmin' (RELOAD and SHUTDOWN privileges):
452echo "update mysql.user set password=password('newpassword') where user='mysql_sysadmin'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
6a46c354 453
5f961775
JR
454For 'mysql' user (ALL privileges, DB admin):
455echo "update mysql.user set password=password('newpassword') where user='mysql'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
6a46c354 456
566e62bb 457NOTE: mysql_sysadmin password should be placed to $MYSQL_CONFIG in
6a46c354 458mysqladmin section. See the manual for more instructions.
566e62bb 459(This user is used at logs rotation and server shutdown)
e9ca44ab 460
5f961775
JR
461END_OF_MSG
462 show "Filling help tables..."
463 ok=0
464 ( echo "use mysql;"; cat /usr/share/mysql/fill_help_tables.sql ) | \
9b5b7a74
ER
465 /usr/sbin/mysqld \
466 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
467 --bootstrap \
468 --skip-grant-tables \
9b5b7a74 469 --skip-innodb \
9b5b7a74
ER
470 --datadir=$MYSQL_DATA_DIR \
471 --user=$MYSQL_USER \
472 --slave-load-tmpdir=$MYSQL_DATA_DIR \
473 --tmpdir=$MYSQL_DATA_DIR \
474 --log-error=$MYSQL_ERRLOG \
da87c30d 475 && ok=1
5f961775
JR
476 if [ "$ok" = 1 ]; then
477 ok
478 else
479 cat << END_OF_MSG
480
481WARNING: HELP FILES ARE NOT COMPLETELY INSTALLED!
482The "HELP" command might not work properly.
16bf26ff 483
e9ca44ab 484END_OF_MSG
5f961775
JR
485 fi
486 else
487 fail
488 cat << END_OF_MSG
e9ca44ab 489Installation of grant tables FAILED!
490
6df74636
ER
491The initialization SQL script was preserved at $MYSQL_DATA_DIR/mysql-init.sql
492
b9c4f95d
ER
493Examine the logs in /var/log/mysql for more information. You can
494also try to start the mysqld daemon with:
e9ca44ab 495
496/usr/sbin/mysqld --skip-grant &
497
dc7a177f 498You can use the command line tool mysql to connect to the mysql
e9ca44ab 499database and look at the grant tables:
500
dc7a177f 501shell> mysql -u mysql mysql
e9ca44ab 502mysql> show tables
503
504Try 'mysqld --help' if you have problems with paths. Setting on
4581ca2d 505logging in $MYSQL_DATA_DIR/mysqld.conf gives you a log in /var/log/mysql/query.log that
e9ca44ab 506may be helpful. The latest information about MySQL is available on the
78b16243 507web at http://www.mysql.com/.
e9ca44ab 508
a3eb9e7b 509Please check PLD Linux ftp site for newer versions of this package.
e9ca44ab 510
511Please consult the MySQL manual section: 'Problems running
512mysql_install_db', and the manual section that describes problems on
513your OS. Another information source is the MySQL email archive.
e9ca44ab 514
515END_OF_MSG
5f961775 516 exit 1
aac2c31f
AM
517 fi
518}
519
520#
521# End of useful functions.
522#
523
323256af 524start() {
5e3157a9 525 local mysqldir
aac2c31f 526 for mysqldir in $DB_CLUSTERS; do
c85758f0 527 mysqlstatus "$mysqldir" start
aac2c31f
AM
528 if [ "$MYSQL_STATUS" = "running" ]; then
529 msg_already_running "MySQL $mysqldir"
530 else
531 mysqlstart "$mysqldir"
532 fi
533 done
534 mysqlsubsys
323256af
ER
535}
536
537stop() {
5e3157a9 538 local mysqldir
aac2c31f 539 for mysqldir in $DB_CLUSTERS; do
c85758f0 540 mysqlstatus "$mysqldir" stop
aac2c31f
AM
541 if [ "$MYSQL_STATUS" = "not running" ]; then
542 msg_not_running "MySQL $mysqldir"
543 else
544 mysqlstop "$mysqldir"
545 fi
546 done
547 mysqlsubsys
323256af
ER
548}
549
7429b124 550condrestart() {
5e3157a9 551 if [ ! -f /var/lock/subsys/mysql ]; then
7429b124
JB
552 msg_not_running "MySQL"
553 RETVAL=$1
5e3157a9 554 return
7429b124 555 fi
5e3157a9
ER
556
557 stop
558 start
7429b124
JB
559}
560
323256af
ER
561RETVAL=0
562case "$action" in
563 start)
33cdd78d 564 start
323256af
ER
565 ;;
566 stop)
33cdd78d 567 stop
aac2c31f 568 ;;
7429b124
JB
569 restart)
570 stop
571 start
572 ;;
573 try-restart)
574 condrestart 0
575 ;;
576 force-reload)
577 condrestart 7
578 ;;
33cdd78d
ER
579 init)
580 for mysqldir in $DB_CLUSTERS; do
581 mysqlinit "$mysqldir"
582 done
583 exit $?
584 ;;
585 flush-logs)
586 for mysqldir in $DB_CLUSTERS; do
587 mysqlgetconfig "$mysqldir"
588 # just if mysqld is really running
589 if /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" ping >/dev/null 2>&1; then
590 /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" flush-logs
591 fi
592 done
593 ;;
aac2c31f
AM
594 status)
595 for mysqldir in $DB_CLUSTERS; do
596 mysqlstatus "$mysqldir"
2bac5c2d 597 if [ "$MYSQL_STATUS" = "running" ]; then
b3be1198
ER
598 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
599 port=${MYSQL_PORT:-3306}
600 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
601 pid=$MYSQL_PID
9e39a858
ER
602 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
603 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
604 nls "\tunix:%s\n" "$socket"
b2bb6a82 605 pids="$pids/$MYSQL_PID/"
2bac5c2d
ER
606 progress "$MYSQL_STATUS"
607 else
27698ac1 608 show "MySQL cluster %s" "$mysqldir"
2bac5c2d
ER
609 progress "$MYSQL_STATUS" "$CFAIL"
610 fi
611 echo
aac2c31f 612 done
b2bb6a82
ER
613
614 for pid in $(/sbin/pidof mysqld); do
615 if [[ $pids != */$pid/* ]]; then
616 running="$running $pid"
617 fi
618 done
b7d0a657 619
a5595931 620 if [ $# = 1 -a "$running" ]; then
b2bb6a82
ER
621 nls "Warning: MySQL Daemon processes not under clusters.conf control:"
622 # see if we can display their status
623 for pid in $running; do
b7d0a657 624 datadir=$(cat /proc/$pid/cmdline | tr '\0' '\n' | fgrep -- --datadir=)
b2bb6a82
ER
625 datadir=${datadir#--datadir=} # strip --datadir
626 mysqldir=${datadir%/mysqldb/db} # strip /mysqldb/db
627 mysqlstatus "$mysqldir"
628 if [ "$MYSQL_STATUS" = "running" ]; then
b3be1198
ER
629 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
630 port=${MYSQL_PORT:-3306}
631 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
9e39a858
ER
632 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
633 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
634 nls "\tunix:%s\n" "$socket"
b2bb6a82
ER
635 progress "$MYSQL_STATUS"
636 else
637 show "MySQL cluster %s" "$mysqldir"
638 progress "$MYSQL_STATUS" "$CFAIL"
639 fi
640 echo
641 done
642 fi
aac2c31f 643 ;;
53a28f77 644 *)
33cdd78d 645 msg_usage "$0 {start|stop|restart|try-restart|force-reload|init|flush-logs|status}"
02e96f2e 646 exit 3
53a28f77 647esac
40c36bca 648
ee9b6a50 649exit $RETVAL
This page took 0.200033 seconds and 4 git commands to generate.